# 地形ラスタ切り出しプラグイン - ヘルプページ

<!-- TOC -->

- [動作確認環境](#動作確認環境)
- [機能説明](#機能説明)
    - [メニュー画面](#メニュー画面)
    - [TIFFからPNGを切り出し](#tiffからpngを切り出し)
    - [PNGからTIFFに変換](#pngからtiffに変換)
- [複数のGeoTIFFファイルを結合する手順](#複数のgeotiffファイルを結合する手順)
- [著作権表示](#著作権表示)

<!-- /TOC -->

-----

## 動作確認環境
- Windows10 64bit
- QGIS3.10.8

-----

## 機能説明

### メニュー画面

プラグインがインストールされると、メニューバーの「プラグイン」に「DemConverter」メニューが追加されます。

同時に、ツールバーに「TIFFからPNGを切り出し」、「PNGからTIFFに変換」、「ヘルプ」ボタンが追加されます。

<img src='imgs/00_01.png'>
<br />
<img src='imgs/00_02.png'>

いずれの赤枠からでも同じ機能に遷移することができます。

-----

### TIFFからPNGを切り出し

一般的なDEM画像（GeoTIFF）の一部の領域を選択し、指定解像度でPNG形式の画像としてタイル化する機能です。

#### 画面説明と使い方

1. プロジェクトに切り出し対象のDEM(GeoTIFF)を追加し、メニューから「TIFFからPNGを切り出し」を開く

    <img src='imgs/01_t2p_01.png'>

2. 下記画像の手順に沿って各種パラメータを入力のうえ「切り出し範囲を選択」ボタンを押下し、範囲選択モードへ移行する

    <img src='imgs/01_t2p_02.png'>
    <br />
    <img src='imgs/01_t2p_03.png'>

3. 切り出したい範囲をマウスドラッグで決定する（生成予定タイルを表すガイド（赤い格子）を参考に）

    <img src='imgs/01_t2p_04.png'>
    <br />
    <img src='imgs/01_t2p_05.png'>

4. 出力先に選択したディレクトリに「output」フォルダが生成され、中に画像ファイル、ワールドファイル、csvファイルが出力される

    <img src='imgs/01_t2p_06.png'>


5. QGISに追加すると、ワールドファイルに適切に地理情報が出力されていることがわかる
    
    <img src='imgs/01_t2p_07.png'>


#### 主な仕様
- 選択するGeoTIFF画像は、Float32型で値が保存されていて、単バンドのグレースケールかつ平面直角座標系である必要があります
    - 複数のGeoTIFF画像を一度にタイル化することは出来ないので、本マニュアルで紹介する[複数のGeoTIFFファイルを結合する手順](#複数のgeotiffファイルを結合する手順)を参考に、タイル化したいGeoTIFFは事前にひとつに結合しておく必要があります
- 出力されるPNG画像は、16bitグレースケールとなります（ピクセル値は0-65535）
- 出力されるPNG画像が表す標高幅は、65.535m、655.35m、6553.5mのいずれかになります（それぞれ、1ピクセル値あたりの標高の増分が0.001m, 0.01m, 0.1mになります＝本プラグインでは標高係数と呼びます）
    - いずれの標高幅になるかは、選択されたGeoTIFF画像および下方余裕幅から自動計算され決定されます
    - PNG画像のピクセル値が0の場合の標高値も同様に自動計算されます（＝本プラグインでは基準標高と呼びます）
    - 逆変換の際に必要となる、基準標高と標高係数は変換パラメータとしてinfo.csvに保存されます
- 指定した出力先にoutputフォルダが生成され、その中にinfo.csvとpngファイル群が出力されます
    - 指定された出力先にすでに同じフォルダ・ファイルが存在していたら、すべて上書きされます
- GeoTIFFにデータが存在しない領域はタイル化後のピクセル値が0となります


-----

### PNGからTIFFに変換

前述のTIFF->PNG変換で生成されたPNGを、GeoTIFFに逆変換する機能です。TIFF->PNG変換時のパラメータがわかっていれば、ほぼ変換前のTIFFを復元することができます。

#### 画面説明と使い方


<!-- gazou -->

※「TIFFからPNGを切り出し」画面説明で出力したpngを例に説明します

1. プロジェクトに変換対象のPNGを追加して「PNGからTIFFに変換」を開く

2. 下記画像に記載の手順に沿って必要事項を入力し「OK」ボタンを押下すると変換処理が実行される（変換対象のPNGと同じフォルダに「info.csv」があれば、パラメータは自動入力される）

    <img src='./imgs/02_p2t_01.png'>
    <br />
    <img src='./imgs/02_p2t_02.png'>

3. 指定したディレクトリに、TIFF画像、ワールドファイル、csvファイルが出力される

    <img src='./imgs/02_p2t_03.png'>

4. TIFF画像をQGISに追加するとピクセル値とパラメータから標高値が復元されていることがわかる

    <img src='./imgs/02_p2t_04.png'>

#### 主な仕様
- 本機能は、「TIFFからPNGを切り出し」機能により生成されたPNGファイルをTIFFファイルへ逆変換するものです
- 選択するPNG画像は、16bitグレースケールである必要があります
    - 32bitのデータを16bitに変換し、再度32bitに逆変換するため、完全に元のGeoTIFFの情報が復元される訳ではありません
- TIFF->PNG変換時に生成されたファイル群が同じディレクトリ構成をしているなら、PNG選択時に自動的にinfo.csvを読み込み、各種パラメータを入力します
    - 同様に、原点位置や1ピクセルあたりの距離などのパラメータも、ワールドファイルが存在していればその値を自動的に入力します
- 出力するGeoTIFFの座標系は平面直角座標系である必要があります
- 出力先として指定したファイル名で、GeoTIFFだけではなくワールドファイルとcsvファイルを出力します
    - 指定されたディレクトリにすでにファイルが存在していたら、すべて上書きされます

-----

## 複数のGeoTIFFファイルを結合する手順

1. 結合したいすべてのGeoTIFFファイルをプロジェクトに追加する

    <img src='./imgs/03_gm_1.png'>

2. メニューバーから「ラスタ」→「結合(gdal_merge)」を開く

    <img src='./imgs/03_gm_2.png'>

3. 結合したいラスターレイヤーを選択する

    <img src='./imgs/03_gm_3.png'>
    <br />
    <img src='./imgs/03_gm_4.png'>

4. 保存先を指定して実行する

    <img src='./imgs/03_gm_5.png'>
    <br />
    <img src='./imgs/03_gm_6.png'>
    <br />
    <img src='./imgs/03_gm_7.png'>

6. 結合されたGeoTIFFが保存されプロジェクトに追加される

    <img src='./imgs/03_gm_8.png'>


-----

## 著作権表示

※本マニュアルの作成に用いたGeoTIFFは、以下の著作物を改変して利用しています

[兵庫県_全域DEM（2010年度～2018年度）]、［兵庫県]